var store = {
		nomesSorteio:  [],	    
	    bancoNomes: [],	     
	    nomesPremiados: [],
	    
	    ponteiro: 0,	    
	    
	    premiar: function(){
	    	store.nomesPremiados.push(store.nomesSorteio[6]);
	    	store.nomesSorteio.splice(6,1);
	    	store.bancoNomes.splice(store.ponteiro - 8, 1);
	    },
	    
	    removerPremiado: function(index){
	    	store.bancoNomes.push(store.nomesPremiados[index]);
	    	store.nomesPremiados.splice(index, 1);
	    },
	    
	    girarNomesSorteio: function(){
	    	store.ponteiro++;

	    	if(store.ponteiro == store.bancoNomes.length + 1){
				store.ponteiro = 0;
			}
	    	
	    	if(store.nomesSorteio.length == 15){
	    		store.nomesSorteio.shift(); 		
	    	}
	    	
			store.nomesSorteio.push(store.bancoNomes[store.ponteiro]);
			
	    }
}

var api = {
	getNomes: async function(){
		return fetch('http://webescola.net.br/sorteio/endpoints/nomes.php')
		.then(response => response.json())
	}	
}


api.getNomes()
.then(nomes => {
	store.bancoNomes.push(...nomes);
	for(const [index, nome] of nomes.entries()){
		if(index == 15) break;
		store.nomesSorteio.push(nome);
		store.ponteiro = index;
	}
})


Vue.component('app-topo', {
	template: `
	  	<div class="row">
	      <div class="col-12 topo">
	      	<img src="imgs/logo.png" />
	      </div>
		</div>
	`
})

Vue.component('sorteio-box', {
	data: function(){
	    return {
	    	nomes: store.nomesSorteio,		    
		    roletaIntervalId: null
	    }
	},
	
	methods: {
		iniciarRoleta: function(){	
			if(this.roletaIntervalId == null){
				this.roletaIntervalId = setInterval(() => store.girarNomesSorteio(), 1);		
			}
		},
		
		pararRoleta: function(){				
			if(this.roletaIntervalId != null){
				clearInterval(this.roletaIntervalId);
			}
			this.roletaIntervalId = null;
		},
		
		adicionarPremiado: function(){
			if(this.roletaIntervalId == null)
				store.premiar();
		}
	},
	
	template: `
	  	<div class="sorteio-box">
	  		<div class="sorteio-botoes">
	  			<span class="botao-green" @click="iniciarRoleta()">SORTEAR</span>
	  			<span class="botao-red" @click="pararRoleta()">PARAR</span>
	  			<span class="botao-green" @click="adicionarPremiado()">CONFIRMAR</span>                			
	  		</div>
	  		<div class="sorteio-nomes">
	  			<ul>
	      			<li v-for="nome in nomes">{{nome}}</li>	      			
	      		</ul>
	  		</div>
	  	</div>
	`
})

Vue.component('premiados-box', {
	data: function(){
	    return {
	    	premiados: store.nomesPremiados
	    }
	},	
	
	methods: {
		removerNomeDaLista: function(index){	
			store.removerPremiado(index)
		},
	},
	
	template: `
		<div class="premiados-box">
	  		<h1>Premiados!</h1>
	  		<ul class="premiados-lista">
  				<li v-for="(nome, index) in premiados">
  					<span>{{nome}}</span> 
  					<i class="fa fa-window-close" aria-hidden="true" @click="removerNomeDaLista(index)"></i>
  				</li>	 
	  		</ul>
	  	</div>
	`
})

	

Vue.component('app-body', {
	template: `
		<div class="row">
			 <div class="col-7">
			  	<sorteio-box />
			</div>
			<div class="col-5">
				<premiados-box />
			</div>
		</div>
	`
})



var app = new Vue({
  el: '#app',
  
  data: {
	  message: 'Hello Vue!'
  },
  
  template: `
	  <div class='container'>
		<app-topo />
		<app-body />
	</div>
  `
})


;